# <img src="https://raw.githubusercontent.com/Rekord/rekord/master/images/rekord-color.png" width="60"> Documentation

### Documentation Outline:

- Introduction
- Conceptual Overview
- Models
  - Options
- Relationships
  - hasOne
  - belongsTo
  - hasMany
  - hasManyThrough
  - Polymorphic
- Collections
  - Filtered
  - Models
  - Paging
- Searching
  - Pagination
  - Load More
- Static Functions
  - all, boot, collect, create, fetch, fetchAll, filtered, find, findOrCreate, get, grab, grabAll, persist, ready, refresh, search, searchPaged
- Timestamps
  - format, type, UTC, current
- Property Resolvers
- Where Expressions
- Comparators
- Batch Operations
- Sharding
- Key Changing
- Files
- Validation *
- Migrations *
- Development Process
- Conflict Management

### Tutorial Outline:

- Installation
- Choosing Implementations
  - Angular
  - jQuery
  - Firebase
  - PouchDB
  - StorkJS
  - PubSub
  - AJAX
- Defining your Models
- Add-Ons
  - Validation
  - Migrations

### Homepage Examples:

- Defining
- Saving and Removing
- Relationships
- Collections
- Searching
